Index: documentViewer.py
===================================================================
--- documentViewer.py	(revision 452)
+++ documentViewer.py	(revision 498)
@@ -559,349 +696,31 @@
         else:
             # online path
+            
             server=self.digilibBaseUrl+"/servlet/Texter?fn="
-            metaUrl=server+url.replace("/mpiwg/online","")
+            metaUrl=server+url
         
         txt=getHttpData(metaUrl)
         if txt is None:
-            raise IOError("Unable to read infoXMLfrom %s"%(url))
-            
-        dom = Parse(txt)
-        return dom
-                        
-        
-    def getAuthinfoFromIndexMeta(self,path,docinfo=None,dom=None,cut=0):
-        """gets authorization info from the index.meta file at path or given by dom"""
-        logging.debug("documentViewer (getauthinfofromindexmeta) path: %s"%(path))
-        
-        access = None
-        
-        if docinfo is None:
-            docinfo = {}
-            
-        if dom is None:
-            for x in range(cut):
-                path=getParentDir(path)
-            dom = self.getDomFromIndexMeta(path)
-       
-        acctype = dom.xpath("//access-conditions/access/@type")
-        if acctype and (len(acctype)>0):
-            access=acctype[0].value
-            if access in ['group', 'institution']:
-                access = getTextFromNode(dom.xpath("//access-conditions/access/name")[0]).lower()
-            
-        docinfo['accessType'] = access
+            logging.error("Unable to read info.xml from %s"%(url))
+            return docinfo
+            
+        dom = ET.fromstring(txt)
+        docinfo['creator']=getText(dom.find(".//author"))
+        docinfo['title']=getText(dom.find(".//title"))
+        docinfo['date']=getText(dom.find(".//date"))
         return docinfo
     
-        
-    def getBibinfoFromIndexMeta(self,path,docinfo=None,dom=None,cut=0):
-        """gets bibliographical info from the index.meta file at path or given by dom"""
-        #logging.debug("documentViewer (getbibinfofromindexmeta) path: %s"%(path))
-        
-        if docinfo is None:
-            docinfo = {}
-        
-        if dom is None:
-            for x in range(cut):
-                path=getParentDir(path)
-            dom = self.getDomFromIndexMeta(path)
-        
-        docinfo['indexMetaPath']=self.getIndexMetaPath(path);
-        
-        #logging.debug("documentViewer (getbibinfofromindexmeta cutted) path: %s"%(path))
-        # put in all raw bib fields as dict "bib"
-        bib = dom.xpath("//bib/*")
-        if bib and len(bib)>0:
-            bibinfo = {}
-            for e in bib:
-                bibinfo[e.localName] = getTextFromNode(e)
-            docinfo['bib'] = bibinfo
-        
-        # extract some fields (author, title, year) according to their mapping
-        metaData=self.metadata.main.meta.bib
-        bibtype=dom.xpath("//bib/@type")
-        if bibtype and (len(bibtype)>0):
-            bibtype=bibtype[0].value
-        else:
-            bibtype="generic"
-            
-        bibtype=bibtype.replace("-"," ") # wrong typesiin index meta "-" instead of " " (not wrong! ROC)
-        docinfo['bib_type'] = bibtype
-        bibmap=metaData.generateMappingForType(bibtype)
-        #logging.debug("documentViewer (getbibinfofromindexmeta) bibmap:"+repr(bibmap))
-        #logging.debug("documentViewer (getbibinfofromindexmeta) bibtype:"+repr(bibtype))
-        # if there is no mapping bibmap is empty (mapping sometimes has empty fields)
-        if len(bibmap) > 0 and len(bibmap['author'][0]) > 0:
-            try:
-                docinfo['author']=getTextFromNode(dom.xpath("//bib/%s"%bibmap['author'][0])[0])
-            except: pass
-            try:
-                docinfo['title']=getTextFromNode(dom.xpath("//bib/%s"%bibmap['title'][0])[0])
-            except: pass
-            try:
-                docinfo['year']=getTextFromNode(dom.xpath("//bib/%s"%bibmap['year'][0])[0])
-            except: pass
-            #logging.debug("documentViewer (getbibinfofromindexmeta) using mapping for %s"%bibtype)
-            try:
-                docinfo['lang']=getTextFromNode(dom.xpath("//bib/lang")[0])
-            except:
-                docinfo['lang']=''
-            try:
-                docinfo['city']=getTextFromNode(dom.xpath("//bib/city")[0])
-            except:
-                docinfo['city']=''
-            try:
-                docinfo['number_of_pages']=getTextFromNode(dom.xpath("//bib/number_of_pages")[0])
-            except:
-                docinfo['number_of_pages']=''
-            try:
-                docinfo['series_volume']=getTextFromNode(dom.xpath("//bib/series_volume")[0])
-            except:
-                docinfo['series_volume']=''
-            try:
-                docinfo['number_of_volumes']=getTextFromNode(dom.xpath("//bib/number_of_volumes")[0])
-            except:
-                docinfo['number_of_volumes']=''
-            try:
-                docinfo['translator']=getTextFromNode(dom.xpath("//bib/translator")[0])
-            except:
-                docinfo['translator']=''
-            try:
-                docinfo['edition']=getTextFromNode(dom.xpath("//bib/edition")[0])
-            except:
-                docinfo['edition']=''
-            try:
-                docinfo['series_author']=getTextFromNode(dom.xpath("//bib/series_author")[0])
-            except:
-                docinfo['series_author']=''
-            try:
-                docinfo['publisher']=getTextFromNode(dom.xpath("//bib/publisher")[0])
-            except:
-                docinfo['publisher']=''
-            try:
-                docinfo['series_title']=getTextFromNode(dom.xpath("//bib/series_title")[0])
-            except:
-                docinfo['series_title']=''
-            try:
-                docinfo['isbn_issn']=getTextFromNode(dom.xpath("//bib/isbn_issn")[0])
-            except:
-                docinfo['isbn_issn']=''           
-        #logging.debug("I NEED BIBTEX %s"%docinfo)
-        return docinfo
-    
-    
-    def getNameFromIndexMeta(self,path,docinfo=None,dom=None,cut=0):
-        """gets name info from the index.meta file at path or given by dom"""
-        if docinfo is None:
-            docinfo = {}
-        
-        if dom is None:
-            for x in range(cut):
-                path=getParentDir(path)
-            dom = self.getDomFromIndexMeta(path)
-
-        docinfo['name']=getTextFromNode(dom.xpath("/resource/name")[0])
-        logging.debug("documentViewer docinfo[name] %s"%docinfo['name'])
-        return docinfo
-    
-    def getDocinfoFromTextTool(self, url, dom=None, docinfo=None):
-        """parse texttool tag in index meta"""
-        logging.debug("documentViewer (getdocinfofromtexttool) url: %s" % (url))
-        if docinfo is None:
-           docinfo = {}
-        if docinfo.get('lang', None) is None:
-            docinfo['lang'] = '' # default keine Sprache gesetzt
-        if dom is None:
-            dom = self.getDomFromIndexMeta(url)
-        
-        archivePath = None
-        archiveName = None
-    
-        archiveNames = dom.xpath("//resource/name")
-        if archiveNames and (len(archiveNames) > 0):
-            archiveName = getTextFromNode(archiveNames[0])
-        else:
-            logging.warning("documentViewer (getdocinfofromtexttool) resource/name missing in: %s" % (url))
-        
-        archivePaths = dom.xpath("//resource/archive-path")
-        if archivePaths and (len(archivePaths) > 0):
-            archivePath = getTextFromNode(archivePaths[0])
-            # clean up archive path
-            if archivePath[0] != '/':
-                archivePath = '/' + archivePath
-            if archiveName and (not archivePath.endswith(archiveName)):
-                archivePath += "/" + archiveName
-        else:
-            # try to get archive-path from url
-            logging.warning("documentViewer (getdocinfofromtexttool) resource/archive-path missing in: %s" % (url))
-            if (not url.startswith('http')):
-                archivePath = url.replace('index.meta', '')
-                
-        if archivePath is None:
-            # we balk without archive-path
-            raise IOError("Missing archive-path (for text-tool) in %s" % (url))
-        
-        imageDirs = dom.xpath("//texttool/image")
-        if imageDirs and (len(imageDirs) > 0):
-            imageDir = getTextFromNode(imageDirs[0])
-            
-        else:
-            # we balk with no image tag / not necessary anymore because textmode is now standard
-            #raise IOError("No text-tool info in %s"%(url))
-            imageDir = ""
-            #xquery="//pb"  
-            docinfo['imagePath'] = "" # keine Bilder
-            docinfo['imageURL'] = ""
-            
-        if imageDir and archivePath:
-            #print "image: ", imageDir, " archivepath: ", archivePath
-            imageDir = os.path.join(archivePath, imageDir)
-            imageDir = imageDir.replace("/mpiwg/online", '')
-            docinfo = self.getDirinfoFromDigilib(imageDir, docinfo=docinfo)
-            docinfo['imagePath'] = imageDir
-            
-            docinfo['imageURL'] = self.digilibBaseUrl + "/servlet/Scaler?fn=" + imageDir
-            
-        viewerUrls = dom.xpath("//texttool/digiliburlprefix")
-        if viewerUrls and (len(viewerUrls) > 0):
-            viewerUrl = getTextFromNode(viewerUrls[0])
-            docinfo['viewerURL'] = viewerUrl
-        
-        # old style text URL
-        textUrls = dom.xpath("//texttool/text")
-        if textUrls and (len(textUrls) > 0):
-            textUrl = getTextFromNode(textUrls[0])
-            if urlparse.urlparse(textUrl)[0] == "": #keine url
-                textUrl = os.path.join(archivePath, textUrl) 
-            # fix URLs starting with /mpiwg/online
-            if textUrl.startswith("/mpiwg/online"):
-                textUrl = textUrl.replace("/mpiwg/online", '', 1)
-            
-            docinfo['textURL'] = textUrl
-        
-
-            #TODO: hack-DW for annalen
-            if (textUrl is not None) and (textUrl.startswith("/permanent/einstein/annalen")):
-                textUrl=textUrl.replace("/permanent/einstein/annalen/","/diverse/de/") 
-                splitted=textUrl.split("/fulltext")
-                textUrl=splitted[0]+".xml"
-                textUrlkurz = string.split(textUrl, ".")[0]
-                docinfo['textURLPathkurz'] = textUrlkurz
-                docinfo['textURLPath'] = textUrl
-                logging.debug("hack")
-                logging.debug(textUrl)
-            
-            
-        # new style text-url-path
-        textUrls = dom.xpath("//texttool/text-url-path")
-        if textUrls and (len(textUrls) > 0):
-            textUrl = getTextFromNode(textUrls[0])
-            docinfo['textURLPath'] = textUrl
-            textUrlkurz = string.split(textUrl, ".")[0]
-            docinfo['textURLPathkurz'] = textUrlkurz
-            #if not docinfo['imagePath']:
-                # text-only, no page images
-                #docinfo = self.getNumTextPages(docinfo)
-                  
-         
-        presentationUrls = dom.xpath("//texttool/presentation")
-        docinfo = self.getBibinfoFromIndexMeta(url, docinfo=docinfo, dom=dom)   # get info von bib tag
-        #docinfo = self.getDownloadfromDocinfoToBibtex(url, docinfo=docinfo, dom=dom)
-        docinfo = self.getNameFromIndexMeta(url, docinfo=docinfo, dom=dom)
-        
-        
-        if presentationUrls and (len(presentationUrls) > 0): # ueberschreibe diese durch presentation informationen 
-             # presentation url ergiebt sich ersetzen von index.meta in der url der fuer die Metadaten
-             # durch den relativen Pfad auf die presentation infos
-            presentationPath = getTextFromNode(presentationUrls[0])
-            if url.endswith("index.meta"): 
-                presentationUrl = url.replace('index.meta', presentationPath)
-            else:
-                presentationUrl = url + "/" + presentationPath
-                
-            docinfo = self.getBibinfoFromTextToolPresentation(presentationUrl, docinfo=docinfo, dom=dom)
-    
-        docinfo = self.getAuthinfoFromIndexMeta(url, docinfo=docinfo, dom=dom)   # get access info
-        
-        return docinfo
-   
-   
-    def getBibinfoFromTextToolPresentation(self,url,docinfo=None,dom=None):
-        """gets the bibliographical information from the preseantion entry in texttools
-        """
-        dom=self.getPresentationInfoXML(url)
-        try:
-            docinfo['author']=getTextFromNode(dom.xpath("//author")[0])
-        except:
-            pass
-        try:
-            docinfo['title']=getTextFromNode(dom.xpath("//title")[0])
-        except:
-            pass
-        try:
-            docinfo['year']=getTextFromNode(dom.xpath("//date")[0])
-        except:
-            pass
-        return docinfo
-    
-    def getDocinfoFromImagePath(self,path,docinfo=None,cut=0):
-        """path ist the path to the images it assumes that the index.meta file is one level higher."""
-        logging.debug("documentViewer (getdocinfofromimagepath) path: %s"%(path))
-        if docinfo is None:
-            docinfo = {}
-        path=path.replace("/mpiwg/online","")
-        docinfo['imagePath'] = path
-        docinfo=self.getDirinfoFromDigilib(path,docinfo=docinfo,cut=cut)
-        
-        pathorig=path
-        for x in range(cut):       
-                path=getParentDir(path)
-        logging.debug("documentViewer (getdocinfofromimagepath) PATH:"+path)
-        imageUrl=self.digilibBaseUrl+"/servlet/Scaler?fn="+path
-        docinfo['imageURL'] = imageUrl
-        
-        #path ist the path to the images it assumes that the index.meta file is one level higher.
-        docinfo = self.getBibinfoFromIndexMeta(pathorig,docinfo=docinfo,cut=cut+1)
-        #docinfo = self.getDownloadfromDocinfoToBibtex(pathorig,docinfo=docinfo,cut=cut+1)
-        docinfo = self.getAuthinfoFromIndexMeta(pathorig,docinfo=docinfo,cut=cut+1)
-        return docinfo
-    
-    
-    def getDocinfo(self, mode, url):
-        """returns docinfo depending on mode"""
-        logging.debug("documentViewer (getdocinfo) mode: %s, url: %s"%(mode,url))
-        # look for cached docinfo in session
-        if self.REQUEST.SESSION.has_key('docinfo'):
-            docinfo = self.REQUEST.SESSION['docinfo']
-            # check if its still current
-            if docinfo is not None and docinfo.get('mode') == mode and docinfo.get('url') == url:
-                logging.debug("documentViewer (getdocinfo) docinfo in session: %s"%docinfo)
-                return docinfo
-        # new docinfo
-        docinfo = {'mode': mode, 'url': url}
-        if mode=="texttool": #index.meta with texttool information
-            docinfo = self.getDocinfoFromTextTool(url, docinfo=docinfo)
-        elif mode=="imagepath":
-            docinfo = self.getDocinfoFromImagePath(url, docinfo=docinfo)
-        elif mode=="filepath":
-            docinfo = self.getDocinfoFromImagePath(url, docinfo=docinfo,cut=1)
-        else:
-            logging.error("documentViewer (getdocinfo) unknown mode: %s!"%mode)
-            raise ValueError("Unknown mode %s! Has to be one of 'texttool','imagepath','filepath'."%(mode))
-                
-        # FIXME: fake texturlpath 
-        if not docinfo.has_key('textURLPath'):
-            docinfo['textURLPath'] = None
-        
-        logging.debug("documentViewer (getdocinfo) docinfo: %s"%docinfo)
-        #logging.debug("documentViewer (getdocinfo) docinfo: %s"%)
-        self.REQUEST.SESSION['docinfo'] = docinfo
-        return docinfo
-               
-    def getPageinfo(self, current, start=None, rows=None, cols=None, docinfo=None, viewMode=None, tocMode=None):
+
+    def getPageinfo(self, current=None, start=None, rows=None, cols=None, docinfo=None, viewMode=None, viewType=None, tocMode=None):
         """returns pageinfo with the given parameters"""
+        logging.debug("getPageInfo(current=%s, start=%s, rows=%s, cols=%s, viewMode=%s, viewType=%s, tocMode=%s)"%(current,start,rows,cols,viewMode,viewType,tocMode))
         pageinfo = {}
+        pageinfo['viewMode'] = viewMode
+        pageinfo['viewType'] = viewType
+        pageinfo['tocMode'] = tocMode
+
         current = getInt(current)
-    
         pageinfo['current'] = current
+        pageinfo['pn'] = current
         rows = int(rows or self.thumbrows)
         pageinfo['rows'] = rows
@@ -910,38 +729,43 @@
         grpsize = cols * rows
         pageinfo['groupsize'] = grpsize
+        # is start is empty use one around current
         start = getInt(start, default=(math.ceil(float(current)/float(grpsize))*grpsize-(grpsize-1)))
         # int(current / grpsize) * grpsize +1))
         pageinfo['start'] = start
-        pageinfo['end'] = start + grpsize
-        if (docinfo is not None) and ('numPages' in docinfo):
-            np = int(docinfo['numPages'])
-            pageinfo['end'] = min(pageinfo['end'], np)
-            pageinfo['numgroups'] = int(np / grpsize)
-            if np % grpsize > 0:
-                pageinfo['numgroups'] += 1        
-        pageinfo['viewMode'] = viewMode
-        pageinfo['tocMode'] = tocMode
+        
+        np = int(docinfo.get('numPages', 0))
+        if np == 0:
+            # numPages unknown - maybe we can get it from text page
+            if docinfo.get('textURLPath', None):
+                # cache text page as well
+                pageinfo['textPage'] = self.getTextPage(mode=viewType, pn=current, docinfo=docinfo, pageinfo=pageinfo)
+                np = int(docinfo.get('numPages', 0))
+                
+        pageinfo['numgroups'] = int(np / grpsize)
+        if np % grpsize > 0:
+            pageinfo['numgroups'] += 1
+
+        pageFlowLtr = docinfo.get('pageFlow', 'ltr') != 'rtl'
+        oddScanLeft = docinfo.get('oddPage', 'left') != 'right'
+        # add zeroth page for two columns
+        pageZero = (cols == 2 and (pageFlowLtr != oddScanLeft))
+        pageinfo['pageZero'] = pageZero
+        pageinfo['pageBatch'] = self.getPageBatch(start=start, rows=rows, cols=cols, pageFlowLtr=pageFlowLtr, pageZero=pageZero, minIdx=1, maxIdx=np)
+                
+        # TODO: do we need this here?
         pageinfo['characterNormalization'] = self.REQUEST.get('characterNormalization','reg')
-        #pageinfo['optionToggle'] = self.REQUEST.get('optionToggle','1')
         pageinfo['query'] = self.REQUEST.get('query','') 
         pageinfo['queryType'] = self.REQUEST.get('queryType','')
         pageinfo['querySearch'] =self.REQUEST.get('querySearch', 'fulltext')
-        pageinfo['textPN'] = self.REQUEST.get('textPN','1')
         pageinfo['highlightQuery'] = self.REQUEST.get('highlightQuery','')
-        
-        pageinfo ['highlightElementPos'] = self.REQUEST.get('highlightElementPos','')
-        pageinfo ['highlightElement'] = self.REQUEST.get('highlightElement','')
-        
-        pageinfo ['xpointer'] = self.REQUEST.get('xpointer','')
-        
-        pageinfo['tocPageSize'] = self.REQUEST.get('tocPageSize', '30')
-        pageinfo['queryPageSize'] =self.REQUEST.get('queryPageSize', '10')
-        pageinfo['tocPN'] = self.REQUEST.get('tocPN', '1')     
-        toc = int (pageinfo['tocPN'])
-        pageinfo['textPages'] =int (toc)
-        
+        pageinfo['tocPageSize'] = getInt(self.REQUEST.get('tocPageSize', 30))
+        pageinfo['queryPageSize'] = getInt(self.REQUEST.get('queryPageSize', 10))
+        pageinfo['tocPN'] = getInt(self.REQUEST.get('tocPN', '1'))
+        pageinfo['searchPN'] = getInt(self.REQUEST.get('searchPN','1'))
+        
+        # limit tocPN
         if 'tocSize_%s'%tocMode in docinfo:
-            tocSize = int(docinfo['tocSize_%s'%tocMode])
-            tocPageSize = int(pageinfo['tocPageSize'])
+            tocSize = docinfo['tocSize_%s'%tocMode]
+            tocPageSize = pageinfo['tocPageSize']
             # cached toc           
             if tocSize%tocPageSize>0:
@@ -949,11 +773,117 @@
             else:
                 tocPages=tocSize/tocPageSize
-            pageinfo['tocPN'] = min (tocPages,toc)                    
-        pageinfo['searchPN'] =self.REQUEST.get('searchPN','1')
-        #pageinfo['sn'] =self.REQUEST.get('sn','')
-        pageinfo['s'] =self.REQUEST.get('s','')
+                
+            pageinfo['tocPN'] = min(tocPages,pageinfo['tocPN'])
+            
         return pageinfo
-    
-def changeDocumentViewer(self,title="",digilibBaseUrl=None,thumbrows=2,thumbcols=5,authgroups='mpiwg',RESPONSE=None):
+
+
+    def getPageBatch(self, start=1, rows=10, cols=2, pageFlowLtr=True, pageZero=False, minIdx=1, maxIdx=0):
+        """returns dict with array of page informations for one screenfull of thumbnails"""
+        batch = {}
+        grpsize = rows * cols
+        if maxIdx == 0:
+            maxIdx = start + grpsize
+
+        nb = int(math.ceil(maxIdx / float(grpsize)))
+        # list of all batch start and end points
+        batches = []
+        if pageZero:
+            ofs = 0
+        else:
+            ofs = 1
+            
+        for i in range(nb):
+            s = i * grpsize + ofs
+            e = min((i + 1) * grpsize + ofs - 1, maxIdx)
+            batches.append({'start':s, 'end':e})
+            
+        batch['batches'] = batches
+
+        pages = []
+        if pageZero and start == 1:
+            # correct beginning
+            idx = 0
+        else:
+            idx = start
+            
+        for r in range(rows):
+            row = []
+            for c in range(cols):
+                if idx < minIdx or idx > maxIdx:
+                    page = {'idx':None}
+                else:
+                    page = {'idx':idx}
+                    
+                idx += 1
+                if pageFlowLtr:
+                    row.append(page)
+                else:
+                    row.insert(0, page) 
+                
+            pages.append(row)
+            
+        if start > 1:
+            batch['prevStart'] = max(start - grpsize, 1)
+        else:
+            batch['prevStart'] = None
+            
+        if start + grpsize < maxIdx:
+            batch['nextStart'] = start + grpsize
+        else:
+            batch['nextStart'] = None
+
+        batch['pages'] = pages
+        return batch
+        
+    def getBatch(self, start=1, size=10, end=0, data=None, fullData=True):
+        """returns dict with information for one screenfull of data."""
+        batch = {}
+        if end == 0:
+            end = start + size                    
+            
+        nb = int(math.ceil(end / float(size)))
+        # list of all batch start and end points
+        batches = []
+        for i in range(nb):
+            s = i * size + 1
+            e = min((i + 1) * size, end)
+            batches.append({'start':s, 'end':e})
+            
+        batch['batches'] = batches
+        # list of elements in this batch
+        this = []
+        j = 0
+        for i in range(start, min(start+size, end)):
+            if data:
+                if fullData:
+                    d = data[i]
+                else:
+                    d = data[j]
+                    j += 1
+            
+            else:
+                d = i+1
+                
+            this.append(d)
+            
+        batch['this'] = this
+        if start > 1:
+            batch['prevStart'] = max(start - size, 1)
+        else:
+            batch['prevStart'] = None
+            
+        if start + size < end:
+            batch['nextStart'] = start + size
+        else:
+            batch['nextStart'] = None
+        
+        return batch
+        
+
+    security.declareProtected('View management screens','changeDocumentViewerForm')    
+    changeDocumentViewerForm = PageTemplateFile('zpt/changeDocumentViewer', globals())
+    
+    def changeDocumentViewer(self,title="",digilibBaseUrl=None,thumbrows=2,thumbcols=5,authgroups='mpiwg',RESPONSE=None):
         """init document viewer"""
         self.title=title
@@ -962,4 +892,10 @@
         self.thumbcols = thumbcols
         self.authgroups = [s.strip().lower() for s in authgroups.split(',')]
+        try:
+            # assume MetaDataFolder instance is called metadata 
+            self.metadataService = getattr(self, 'metadata')
+        except Exception, e:
+            logging.error("Unable to find MetaDataFolder 'metadata': "+str(e))
+
         if RESPONSE is not None:
             RESPONSE.redirect('manage_main')
@@ -977,36 +913,2 @@
     if RESPONSE is not None:
         RESPONSE.redirect('manage_main')
-
-## DocumentViewerTemplate class
-class DocumentViewerTemplate(ZopePageTemplate):
-    """Template for document viewer"""
-    meta_type="DocumentViewer Template"
-
-
-def manage_addDocumentViewerTemplateForm(self):
-    """Form for adding"""
-    pt=PageTemplateFile('zpt/addDocumentViewerTemplate', globals()).__of__(self)
-    return pt()
-
-def manage_addDocumentViewerTemplate(self, id='viewer_main', title=None, text=None,
-                           REQUEST=None, submit=None):
-    "Add a Page Template with optional file content."
-
-    self._setObject(id, DocumentViewerTemplate(id))
-    ob = getattr(self, id)
-    txt=file(os.path.join(package_home(globals()),'zpt/viewer_main.zpt'),'r').read()
-    logging.info("txt %s:"%txt)
-    ob.pt_edit(txt,"text/html")
-    if title:
-        ob.pt_setTitle(title)
-    try:
-        u = self.DestinationURL()
-    except AttributeError:
-        u = REQUEST['URL1']
-        
-    u = "%s/%s" % (u, urllib.quote(id))
-    REQUEST.RESPONSE.redirect(u+'/manage_main')
-    return ''
-
-
-    
